#ifndef	__LABYRINTHES
#define __LABYRINTHES


typedef	unsigned char	uint8;
typedef signed char	sint8;
typedef	unsigned short	uint16;
typedef signed short	sint16;
typedef unsigned long	uint32;
typedef signed long	sint32;


typedef struct
{
	uint8	h, l;
	uint8	*donnees;
} lab;


// Les donnes du labyrinthe:
//	Pour chaque case, on indique s'il y a un mur en haut et s'il y a un
//	mur  gauche; cela ce fait en utilisant les valeurs suivantes:
#define	MUR_HAUT	0x01
#define MUR_GAUCHE	0x02


// Cration d'un labyrinthe vide de taille donne
lab*	lab_alloueMemoire(uint8 width, uint8 height);
// Destruction d'un labyrinthe (libration de la mmoire)
void	lab_detruit(lab *l);
// Enregistre le labyrinthe dans un fichier
uint8	lab_sauvegarde(const lab *l, const char *nomFichier);
// Cre un labyrinthe en le chargeant depuis un fichier
lab*	lab_charge(const char *nomFichier);

// Modifie le contenu d'une case
void	lab_modifieCase(lab *l, uint8 x, uint8 y, uint8 flagsMurs);
// Verifie si une case a un mur en haut
uint8	lab_murEnHaut(lab *l, uint8 x, uint8 y);
// Verifie si une case a un mur  gauche
uint8	lab_murAGauche(lab *l, uint8 x, uint8 y);

// Affichage du labyrinthe
uint8	lab_affiche(lab *l);

// Generer un labyrinthe alatoire
void	lab_generer(lab *l);


#endif
